// Copyright (c) 1998, Microsoft Interactive Developer
// Author: Aaron Skonnard
//
// AddAutoDialAddressDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RasJazz.h"
#include "AddAutoDialAddressDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAddAutoDialAddressDlg dialog


CAddAutoDialAddressDlg::CAddAutoDialAddressDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAddAutoDialAddressDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAddAutoDialAddressDlg)
	m_strPhonebook = _T("");
	m_strAddress = _T("");
	//}}AFX_DATA_INIT
}


void CAddAutoDialAddressDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddAutoDialAddressDlg)
	DDX_Control(pDX, IDC_EDIT_ADDRESS, m_Address);
	DDX_Control(pDX, IDC_COMBO_PHONEBOOK, m_Phonebook);
	DDX_CBString(pDX, IDC_COMBO_PHONEBOOK, m_strPhonebook);
	DDX_Text(pDX, IDC_EDIT_ADDRESS, m_strAddress);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAddAutoDialAddressDlg, CDialog)
	//{{AFX_MSG_MAP(CAddAutoDialAddressDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddAutoDialAddressDlg message handlers

BOOL CAddAutoDialAddressDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
    LPRASENTRYNAME lpRasEntry;
    DWORD dwBuf, dwEntry, dwRet;
	CString strRet;

	// malloc initial buffer
    dwBuf = sizeof(RASENTRYNAME);
    if ((lpRasEntry = (LPRASENTRYNAME)malloc((UINT)dwBuf)) != NULL) 
    {
		//set size for version tracking
        lpRasEntry->dwSize = sizeof(RASENTRYNAME);
        dwRet = RasEnumEntries(NULL, NULL, lpRasEntry, &dwBuf, &dwEntry);
        if (dwRet == ERROR_BUFFER_TOO_SMALL)
        {
			// buffer too small - realloc size in dwBuf
            if ((lpRasEntry = (LPRASENTRYNAME)realloc(lpRasEntry, (UINT)dwBuf)) != NULL)
            {
                dwRet = RasEnumEntries(NULL, NULL, lpRasEntry, &dwBuf, &dwEntry);
            }
            else
            {
				free(lpRasEntry);
				return TRUE;
            }
		}
        else if (dwRet != 0) // other error
        { 
			free(lpRasEntry);
			return TRUE;
        }
		//succeeded
        if (dwRet == 0)  
        {
			//fill in combo box
			for(DWORD nIndex = 0; nIndex < dwEntry; nIndex++)
			{
				CString strEntry;
				strEntry.Format("%s", lpRasEntry[nIndex].szEntryName);
				m_Phonebook.AddString(strEntry);
			}
			if (m_Phonebook.GetCount() > 0) 
				m_Phonebook.SetCurSel(0);
		}
		free(lpRasEntry);
	}
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAddAutoDialAddressDlg::OnOK() 
{
	UpdateData(TRUE);

	if (m_strAddress.IsEmpty())
	{
		AfxMessageBox("You must enter an address", MB_OK);
		m_Address.SetFocus();
		return;
	}
	if (m_strPhonebook.IsEmpty())
	{
		AfxMessageBox("You must select a phonebook entry", MB_OK);
		m_Phonebook.SetFocus();
		return;
	}
	
	RASAUTODIALENTRY lppAutoDialEntry[1];
	lppAutoDialEntry[0].dwSize = sizeof(RASAUTODIALENTRY);
	lppAutoDialEntry[0].dwFlags = 0;
	lppAutoDialEntry[0].dwDialingLocation = 1;
	strcpy(lppAutoDialEntry[0].szEntry, m_strPhonebook.GetBuffer(0));

	//add address and phonebook entry to autodial mapping database
	DWORD dwRet = RasSetAutodialAddress(m_strAddress.GetBuffer(0), 0, lppAutoDialEntry, 
		sizeof(RASAUTODIALENTRY), 1);
	
	CDialog::OnOK();
}
