// Copyright (c) 1998, Microsoft Interactive Developer
// Author: Aaron Skonnard
//
// AutoDialAddressesDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RasJazz.h"
#include "AutoDialAddressesDlg.h"
#include "AddAutoDialAddressDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAutoDialAddressesDlg dialog


CAutoDialAddressesDlg::CAutoDialAddressesDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAutoDialAddressesDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAutoDialAddressesDlg)
	//}}AFX_DATA_INIT
}


void CAutoDialAddressesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAutoDialAddressesDlg)
	DDX_Control(pDX, IDC_LIST_ADDRESSES, m_Addresses);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAutoDialAddressesDlg, CDialog)
	//{{AFX_MSG_MAP(CAutoDialAddressesDlg)
	ON_BN_CLICKED(IDC_ADD_ADDRESS, OnAddAddress)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAutoDialAddressesDlg message handlers

void CAutoDialAddressesDlg::OnAddAddress() 
{
	CAddAutoDialAddressDlg dlg;
	if (IDOK == dlg.DoModal())
		m_Addresses.AddString(dlg.m_strAddress);
}

BOOL CAutoDialAddressesDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	LPTSTR *lppAddresses = NULL;
	DWORD dwSize, dwAddresses;

	DWORD dwRet = RasEnumAutodialAddresses(lppAddresses, &dwSize, &dwAddresses);
	if (dwSize)
	{
		lppAddresses = (LPTSTR*)malloc(dwSize);
		dwRet = RasEnumAutodialAddresses(lppAddresses, &dwSize, &dwAddresses);
	}

	ULONG i;
	for (i=0; i<dwAddresses; i++)
		m_Addresses.AddString(lppAddresses[i]);

	if (lppAddresses)
		free(lppAddresses);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

