// Copyright (c) 1998, Microsoft Interactive Developer
// Author: Aaron Skonnard
//
// AutoDialSettingsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RasJazz.h"
#include "AutoDialSettingsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAutoDialSettingsDlg dialog


CAutoDialSettingsDlg::CAutoDialSettingsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAutoDialSettingsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAutoDialSettingsDlg)
	m_bDisableAutoDial = FALSE;
	m_bDisableDialog = FALSE;
	m_strAddressMax = _T("");
	m_strTimeout = _T("");
	//}}AFX_DATA_INIT
}


void CAutoDialSettingsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAutoDialSettingsDlg)
	DDX_Check(pDX, IDC_CHECK_DISABLE_AUTODIAL, m_bDisableAutoDial);
	DDX_Check(pDX, IDC_CHECK_DISABLE_DIALOG, m_bDisableDialog);
	DDX_Text(pDX, IDC_EDIT_ADDRESS_MAX, m_strAddressMax);
	DDX_Text(pDX, IDC_EDIT_TIMEOUT_VALUE, m_strTimeout);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAutoDialSettingsDlg, CDialog)
	//{{AFX_MSG_MAP(CAutoDialSettingsDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAutoDialSettingsDlg message handlers

BOOL CAutoDialSettingsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	DWORD dwDisableAutoDial, dwDisableDlg, dwAddressMax, dwTimeout, dwSize;
	dwSize = sizeof(DWORD);

	RasGetAutodialParam(RASADP_LoginSessionDisable, &dwDisableAutoDial, &dwSize);
	RasGetAutodialParam(RASADP_DisableConnectionQuery, &dwDisableDlg, &dwSize);
	RasGetAutodialParam(RASADP_SavedAddressesLimit, &dwAddressMax, &dwSize);
	RasGetAutodialParam(RASADP_FailedConnectionTimeout, &dwTimeout, &dwSize);

	m_bDisableAutoDial = (dwDisableAutoDial != 0);
	m_bDisableDialog = (dwDisableDlg != 0);
	m_strAddressMax.Format("%d", dwAddressMax);
	m_strTimeout.Format("%d", dwTimeout);

	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAutoDialSettingsDlg::OnOK() 
{
	UpdateData(TRUE);

	DWORD dwDisableAutoDial, dwDisableDlg, dwAddressMax, dwTimeout, dwSize;

	dwSize = sizeof(DWORD);
	dwDisableAutoDial = (DWORD)m_bDisableAutoDial;
	dwDisableDlg = (DWORD)m_bDisableDialog;
	dwAddressMax = atoi(m_strAddressMax);
	dwTimeout = atoi(m_strTimeout);

	RasSetAutodialParam(RASADP_LoginSessionDisable, &dwDisableAutoDial, dwSize);
	RasSetAutodialParam(RASADP_DisableConnectionQuery, &dwDisableDlg, dwSize);
	RasSetAutodialParam(RASADP_SavedAddressesLimit, &dwAddressMax, dwSize);
	RasSetAutodialParam(RASADP_FailedConnectionTimeout, &dwTimeout, dwSize);
	
	CDialog::OnOK();
}
