// BugTrackerView.h : interface of the CBugTrackerView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_BUGTRACKERVIEW_H__F02ED76C_F995_11D1_9912_004033D06B6E__INCLUDED_)
#define AFX_BUGTRACKERVIEW_H__F02ED76C_F995_11D1_9912_004033D06B6E__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define ID_LIST_CONTROL 1000


class CBugTrackerView : public CView
{
protected: // create from serialization only
	CBugTrackerView();
	DECLARE_DYNCREATE(CBugTrackerView)

// Attributes
public:
	CBugTrackerDoc* GetDocument();

	//list of bugs
	CListCtrl m_ListCtrl;

// Operations
public:
	//parsing helper functions
	void ParseBugs(char *lpszResponse);
	void ParseBug(char* lpszBug);
	void SendRequest(LPCTSTR lpszObject, CString& strData);
	CString GetNameValue(char *pName, char *pResponse);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBugTrackerView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBugTrackerView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CBugTrackerView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDblclkListResult(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnNewBug();
	afx_msg void OnRefreshBugs();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in BugTrackerView.cpp
inline CBugTrackerDoc* CBugTrackerView::GetDocument()
   { return (CBugTrackerDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BUGTRACKERVIEW_H__F02ED76C_F995_11D1_9912_004033D06B6E__INCLUDED_)
