// BugsSet.cpp : implementation file
//

#include "stdafx.h"
#include "BugTracker.h"
#include "BugsSet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBugsSet

IMPLEMENT_DYNAMIC(CBugsSet, CDaoRecordset)

CBugsSet::CBugsSet(CDaoDatabase* pdb)
	: CDaoRecordset(pdb)
{
	//{{AFX_FIELD_INIT(CBugsSet)
	m_ID = 0;
	m_Date = _T("");
	m_ReportedBy = _T("");
	m_Status = 0;
	m_Description = _T("");
	m_Notes = _T("");
	m_Priority = 0;
	m_nFields = 7;
	//}}AFX_FIELD_INIT
	m_nDefaultType = dbOpenTable;
}


CString CBugsSet::GetDefaultDBName()
{
	return _T("..\\bugs.mdb");
}

CString CBugsSet::GetDefaultSQL()
{
	return _T("[Bugs]");
}

void CBugsSet::DoFieldExchange(CDaoFieldExchange* pFX)
{
	//{{AFX_FIELD_MAP(CBugsSet)
	pFX->SetFieldType(CDaoFieldExchange::outputColumn);
	DFX_Long(pFX, _T("[ID]"), m_ID);
	DFX_Text(pFX, _T("[Date]"), m_Date);
	DFX_Text(pFX, _T("[ReportedBy]"), m_ReportedBy);
	DFX_Long(pFX, _T("[Status]"), m_Status);
	DFX_Text(pFX, _T("[Description]"), m_Description);
	DFX_Text(pFX, _T("[Notes]"), m_Notes);
	DFX_Long(pFX, _T("[Priority]"), m_Priority);
	//}}AFX_FIELD_MAP
}

BOOL CBugsSet::FindBugByID(long lID)
{
	SetCurrentIndex("ID");
	COleVariant oVar((long)lID);
	return Seek("=", &oVar);
}


/////////////////////////////////////////////////////////////////////////////
// CBugsSet diagnostics

#ifdef _DEBUG
void CBugsSet::AssertValid() const
{
	CDaoRecordset::AssertValid();
}

void CBugsSet::Dump(CDumpContext& dc) const
{
	CDaoRecordset::Dump(dc);
}
#endif //_DEBUG
