// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "BugTracker.h"
#include "ServerInfoDlg.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_COMMAND(ID_SERVER_INFO, OnServerInfo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	int cx, cy, x, y;
	
	CWinApp* pApp = AfxGetApp();

	cx = pApp->GetProfileInt(REG_KEY_SETTINGS, "cx", 300);
	cy = pApp->GetProfileInt(REG_KEY_SETTINGS, "cy", 150);
	x = pApp->GetProfileInt(REG_KEY_SETTINGS, "x", 50);
	y = pApp->GetProfileInt(REG_KEY_SETTINGS, "y", 50);
	
	MoveWindow(x, y, cx, cy);

	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	cs.style = WS_OVERLAPPED | WS_SYSMENU | WS_BORDER | WS_THICKFRAME;
	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::OnDestroy() 
{
	int cx, cy, x, y;
	RECT rect;

	GetWindowRect(&rect);
	cx = rect.right-rect.left;
	cy = rect.bottom-rect.top;

	CWinApp* pApp = AfxGetApp();
	cx = pApp->WriteProfileInt(REG_KEY_SETTINGS, "cx", cx);
	cy = pApp->WriteProfileInt(REG_KEY_SETTINGS, "cy", cy);
	x = pApp->WriteProfileInt(REG_KEY_SETTINGS, "x", rect.left);
	y = pApp->WriteProfileInt(REG_KEY_SETTINGS, "y", rect.top);	

	CFrameWnd::OnDestroy();
}

void CMainFrame::OnServerInfo() 
{
	CWinApp* pApp = AfxGetApp();

	CServerInfoDlg dlg;
	dlg.m_strServer = pApp->GetProfileString(REG_KEY_SETTINGS, "server", "aarons.axtech.com");
	dlg.m_nPort = pApp->GetProfileInt(REG_KEY_SETTINGS, "port", 80);
	dlg.m_strPath = pApp->GetProfileString(REG_KEY_SETTINGS, "path", "/scripts/bugs.dll?");
	dlg.m_nServerType = pApp->GetProfileInt(REG_KEY_SETTINGS, "type", 0);

	if (IDCANCEL == dlg.DoModal())
		return;

	pApp->WriteProfileString(REG_KEY_SETTINGS, "server", dlg.m_strServer);
	pApp->WriteProfileInt(REG_KEY_SETTINGS, "port", dlg.m_nPort);
	pApp->WriteProfileString(REG_KEY_SETTINGS, "path", dlg.m_strPath);
	pApp->WriteProfileInt(REG_KEY_SETTINGS, "type", dlg.m_nServerType);
}

