// BUGS.CPP - Implementation file for your Internet Server
//    Bugs Extension

#include "stdafx.h"
#include "Bugs.h"
#include "BSet.h"

#define SEP	"\xFF"

///////////////////////////////////////////////////////////////////////
// The one and only CWinApp object
// NOTE: You may remove this object if you alter your project to no
// longer use MFC in a DLL.

CWinApp theApp;

///////////////////////////////////////////////////////////////////////
// command-parsing map

BEGIN_PARSE_MAP(CBugsExtension, CHttpServer)
	ON_PARSE_COMMAND(Default, CBugsExtension, ITS_EMPTY)
	DEFAULT_PARSE_COMMAND(Default, CBugsExtension)
	ON_PARSE_COMMAND(refresh, CBugsExtension, ITS_EMPTY)
	ON_PARSE_COMMAND(addeditbug, CBugsExtension, ITS_I4 ITS_PSTR ITS_PSTR ITS_I4 ITS_PSTR ITS_PSTR ITS_I4)
	ON_PARSE_COMMAND_PARAMS("id=0 date=Unavailable reportedby=Unavailable status=0 description=Unavailable notes=Unavailable priority=0")
END_PARSE_MAP(CBugsExtension)


///////////////////////////////////////////////////////////////////////
// The one and only CBugsExtension object

CBugsExtension theExtension;


///////////////////////////////////////////////////////////////////////
// CBugsExtension implementation

CBugsExtension::CBugsExtension()
{
}

CBugsExtension::~CBugsExtension()
{
}

BOOL CBugsExtension::GetExtensionVersion(HSE_VERSION_INFO* pVer)
{
	// Call default implementation for initialization
	CHttpServer::GetExtensionVersion(pVer);

	// Load description string
	TCHAR sz[HSE_MAX_EXT_DLL_NAME_LEN+1];
	ISAPIVERIFY(::LoadString(AfxGetResourceHandle(),
			IDS_SERVER, sz, HSE_MAX_EXT_DLL_NAME_LEN));
	_tcscpy(pVer->lpszExtensionDesc, sz);
	return TRUE;
}

///////////////////////////////////////////////////////////////////////
// CBugsExtension command handlers

void CBugsExtension::Default(CHttpServerContext* pCtxt)
{
	StartContent(pCtxt);
	WriteTitle(pCtxt);

	*pCtxt << _T("This default message was produced by the Internet");
	*pCtxt << _T(" Server DLL Wizard. Edit your CBugsExtension::Default()");
	*pCtxt << _T(" implementation to change it.\r\n");

	EndContent(pCtxt);
}


void CBugsExtension::refresh(CHttpServerContext* pCtxt)
{
	CBSet bugs;
	int i=0;
	CString strBugTag;

	//open DB and make sure it's not empty
	bugs.Open();
	if (bugs.IsEOF() && bugs.IsBOF())
		return;

	//send all bugs to CHttpServerContext
	while (!bugs.IsEOF())
	{
		strBugTag.Format("Bug%d=", i++);
		*pCtxt << strBugTag << bugs.m_ID << SEP << bugs.m_Date << SEP 
			   << bugs.m_ReportedBy << SEP << bugs.m_Status << SEP 
			   << bugs.m_Description << SEP << bugs.m_Notes << SEP 
			   << bugs.m_Priority << SEP << "<eor>";
		//move to next bug
		bugs.MoveNext();
	}
	bugs.Close();
}

void CBugsExtension::addeditbug(CHttpServerContext* pCtxt, long lID, LPCTSTR lpszDate, LPCTSTR lpszReportedBy, 
								long lStatus, LPCTSTR lpszDescription, LPCTSTR lpszNotes, long lPriority)
{
	CBSet bugs;
	bugs.Open();

	if (lID == 0)
	{
		//adding a new bug
		bugs.AddNew();
	}
	else
	{
		//updating an existing bug 
		while (!bugs.IsEOF())
		{
			//try to find bug
			if (bugs.m_ID == lID)
				break;
			bugs.MoveNext();
		}
		//if bug was found, edit, otherwise add
		if (bugs.m_ID == lID)
			bugs.Edit();
		else 
			bugs.AddNew();
	}

	bugs.m_Date = lpszDate;
	bugs.m_ReportedBy = lpszReportedBy;
	bugs.m_Status = lStatus;
	bugs.m_Description = lpszDescription;
	bugs.m_Notes = lpszNotes;
	bugs.m_Priority = lPriority;
	bugs.Update();
	bugs.Close();

	//fresh the client list
	refresh(pCtxt);
}


// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CBugsExtension, CHttpServer)
	//{{AFX_MSG_MAP(CBugsExtension)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0



///////////////////////////////////////////////////////////////////////
// If your extension will not use MFC, you'll need this code to make
// sure the extension objects can find the resource handle for the
// module.  If you convert your extension to not be dependent on MFC,
// remove the comments arounn the following AfxGetResourceHandle()
// and DllMain() functions, as well as the g_hInstance global.

/****

static HINSTANCE g_hInstance;

HINSTANCE AFXISAPI AfxGetResourceHandle()
{
	return g_hInstance;
}

BOOL WINAPI DllMain(HINSTANCE hInst, ULONG ulReason,
					LPVOID lpReserved)
{
	if (ulReason == DLL_PROCESS_ATTACH)
	{
		g_hInstance = hInst;
	}

	return TRUE;
}

****/

