// Copyright (c) 1998, Microsoft Interactive Developer
// Author: Aaron Skonnard
//
// EntrySettingsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RasJazz.h"
#include "EntrySettingsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEntrySettingsDlg dialog


CEntrySettingsDlg::CEntrySettingsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEntrySettingsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEntrySettingsDlg)
	m_strPhonebook = _T("");
	m_strArea = _T("");
	m_strAutoDialDLL = _T("");
	m_strAutoDialFunc = _T("");
	m_strPhone = _T("");
	m_strDevice = _T("");
	//}}AFX_DATA_INIT
}


void CEntrySettingsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEntrySettingsDlg)
	DDX_Control(pDX, IDC_COMBO_PHONEBOOK_SETTINGS, m_Phonebook);
	DDX_CBString(pDX, IDC_COMBO_PHONEBOOK_SETTINGS, m_strPhonebook);
	DDX_Text(pDX, IDC_EDIT_AREA_CODE, m_strArea);
	DDX_Text(pDX, IDC_EDIT_AUTODIAL_DLL, m_strAutoDialDLL);
	DDX_Text(pDX, IDC_EDIT_AUTODIAL_FUNC, m_strAutoDialFunc);
	DDX_Text(pDX, IDC_EDIT_PHONE, m_strPhone);
	DDX_Text(pDX, IDC_EDIT_DEVICE_NAME, m_strDevice);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEntrySettingsDlg, CDialog)
	//{{AFX_MSG_MAP(CEntrySettingsDlg)
	ON_CBN_SELCHANGE(IDC_COMBO_PHONEBOOK_SETTINGS, OnSelchangeComboPhonebookSettings)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEntrySettingsDlg message handlers

BOOL CEntrySettingsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
    LPRASENTRYNAME lpRasEntry;
    DWORD dwBuf, dwEntry, dwRet;
	CString strRet;

	// malloc initial buffer
    dwBuf = sizeof(RASENTRYNAME);
    if ((lpRasEntry = (LPRASENTRYNAME)malloc((UINT)dwBuf)) != NULL) 
    {
		//set size for version tracking
        lpRasEntry->dwSize = sizeof(RASENTRYNAME);
        dwRet = RasEnumEntries(NULL, NULL, lpRasEntry, &dwBuf, &dwEntry);
        if (dwRet == ERROR_BUFFER_TOO_SMALL)
        {
			// buffer too small - realloc size in dwBuf
            if ((lpRasEntry = (LPRASENTRYNAME)realloc(lpRasEntry, (UINT)dwBuf)) != NULL)
            {
                dwRet = RasEnumEntries(NULL, NULL, lpRasEntry, &dwBuf, &dwEntry);
            }
            else
            {
				free(lpRasEntry);
				return TRUE;
            }
		}
        else if (dwRet != 0) // other error
        { 
			free(lpRasEntry);
			return TRUE;
        }
		//succeeded
        if (dwRet == 0)  
        {
			//fill in combo box
			for(DWORD nIndex = 0; nIndex < dwEntry; nIndex++)
			{
				CString strEntry;
				strEntry.Format("%s", lpRasEntry[nIndex].szEntryName);
				m_Phonebook.AddString(strEntry);
			}
			if (m_Phonebook.GetCount() > 0) 
			{
				m_Phonebook.SetCurSel(0);
				UpdateData(TRUE);
			}
		}
		free(lpRasEntry);
	}
	OnSelchangeComboPhonebookSettings();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CEntrySettingsDlg::OnOK() 
{
	UpdateData(TRUE);

	RASENTRY Entry;
	Entry.dwSize = sizeof(RASENTRY);
	Entry.dwAlternateOffset = 0;
	strcpy(Entry.szAreaCode, m_strArea);
	strcpy(Entry.szLocalPhoneNumber, m_strPhone);
	strcpy(Entry.szDeviceName, m_strDevice);
	strcpy(Entry.szAutodialDll, m_strAutoDialDLL);
	strcpy(Entry.szAutodialFunc, m_strAutoDialFunc);

	DWORD dwSize = sizeof(Entry);
	DWORD dwRet = RasSetEntryProperties( NULL, m_strPhonebook.GetBuffer(0), &Entry, dwSize, NULL, 0);
	
	CDialog::OnOK();
}

void CEntrySettingsDlg::OnSelchangeComboPhonebookSettings() 
{
	CString strEntry;
	m_Phonebook.GetLBText(m_Phonebook.GetCurSel(), strEntry);
	m_strPhonebook = strEntry;

	RASENTRY *lpEntry = NULL;
	DWORD dwEntrySize = 0;
	DWORD dwRet = RasGetEntryProperties( NULL, strEntry.GetBuffer(0), lpEntry, &dwEntrySize, NULL, NULL);
	if (dwRet == ERROR_BUFFER_TOO_SMALL)
	{
		lpEntry = (RASENTRY*)malloc(dwEntrySize);
		lpEntry->dwSize = sizeof(RASENTRY);
		dwRet = RasGetEntryProperties( NULL, strEntry.GetBuffer(0), lpEntry, &dwEntrySize, NULL, NULL);
		if (!dwRet)
		{
			m_strArea = lpEntry->szAreaCode;
			m_strPhone = lpEntry->szLocalPhoneNumber;
			m_strDevice = lpEntry->szDeviceName;
			m_strAutoDialDLL = lpEntry->szAutodialDll;
			m_strAutoDialFunc = lpEntry->szAutodialFunc;
		}
		free( lpEntry );
	}
	UpdateData(FALSE);	
}
