// HttpAppDlg.cpp : implementation file
//

#include "stdafx.h"
#include "HttpApp.h"
#include "HttpAppDlg.h"
#include "HttpRequestDlg.h"
#include <wininet.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHttpAppDlg dialog

CHttpAppDlg::CHttpAppDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHttpAppDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHttpAppDlg)
	m_strResult = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CHttpAppDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHttpAppDlg)
	DDX_Text(pDX, IDC_EDIT_RESULT, m_strResult);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHttpAppDlg, CDialog)
	//{{AFX_MSG_MAP(CHttpAppDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHttpAppDlg message handlers

BOOL CHttpAppDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CHttpAppDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CHttpAppDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CHttpAppDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL QueryInfoStatusCode(HINTERNET hRequest, DWORD& dwStatusCode) 
{
	DWORD dwLen = sizeof(DWORD);
	return HttpQueryInfo(hRequest, HTTP_QUERY_STATUS_CODE | 
						HTTP_QUERY_FLAG_NUMBER, (LPVOID)&dwStatusCode, 
						&dwLen, NULL);
}

BOOL QueryInfoStatusText(HINTERNET hRequest, CString& strStatus) 
{
	DWORD dwLen = 255;
	CHAR szBuffer[255];
	BOOL bRet = HttpQueryInfo(hRequest, HTTP_QUERY_STATUS_TEXT, (LPVOID)szBuffer, 
						&dwLen, NULL);
	if (bRet) strStatus = szBuffer;
	return bRet;
}

void CHttpAppDlg::OnOK() 
{
	HINTERNET hOpenHandle,  hConnectHandle, hResourceHandle;
	DWORD dwError = ERROR_INTERNET_FORCE_RETRY, dwErrorCode;
    CHAR lpszBuffer[256];
    DWORD dwRead, dwFlags, dwStatus;
	CString strStatus;
	CHttpRequestDlg dlg;

	if (IDCANCEL == dlg.DoModal())
		return;
	m_strResult.Empty();

	// Initialize WinInet and create the Internet session
	hOpenHandle = InternetOpen("HttpApp/1.0", INTERNET_OPEN_TYPE_PRECONFIG, 
							   NULL, NULL, 0);
	if (!hOpenHandle)
		return;
	
	// check to see if the user wants to use SSL
	dwFlags = (dlg.m_nPort == 443) ? INTERNET_FLAG_SECURE : 0;

	// establish the connection with the HTTP server
	hConnectHandle = InternetConnect(hOpenHandle, dlg.m_strServer, 
									 dlg.m_nPort, dlg.m_strUserName, dlg.m_strPassword,
									 INTERNET_SERVICE_HTTP, 0, 0);
	if (!hConnectHandle)
	{
		InternetCloseHandle(hOpenHandle);
		return;
	}

	// create the HTTP request
	hResourceHandle = HttpOpenRequest(hConnectHandle, dlg.m_strMethod, dlg.m_strURI,
									  NULL, NULL, NULL, dwFlags, 0);

	if (!hResourceHandle)
	{
		InternetCloseHandle(hConnectHandle);
		InternetCloseHandle(hOpenHandle);
		return;
	}

	// keep sending until authentication is successful
	while ( ERROR_INTERNET_FORCE_RETRY == dwError)
	{
		HttpSendRequest(hResourceHandle, NULL, 0, (LPVOID)dlg.m_strData.GetBuffer(0), 
						dlg.m_strData.GetLength());
		dlg.m_strData.ReleaseBuffer();
		//  dwErrorCode stores the error code associated with the call to HttpSendRequest.  
		dwErrorCode = hResourceHandle ? ERROR_SUCCESS : GetLastError();
		dwError = InternetErrorDlg(GetSafeHwnd(), hResourceHandle, dwErrorCode, 
								   FLAGS_ERROR_UI_FILTER_FOR_ERRORS | 
								   FLAGS_ERROR_UI_FLAGS_CHANGE_OPTIONS |
								   FLAGS_ERROR_UI_FLAGS_GENERATE_DATA,
								   NULL);
	}

	if (!QueryInfoStatusCode(hResourceHandle, dwStatus))
		AfxMessageBox("Error in QueryInfoStatusCode");
	else
	{
		if (HTTP_STATUS_OK != dwStatus)
		{
			CString strMsgFormat("HTTP Status Code: %d, Reason: %s"), strMsg;
			if (!QueryInfoStatusText(hResourceHandle, strStatus))
				strMsg = "Unknown";
			strMsg.Format(strMsgFormat, dwStatus, strStatus);
			AfxMessageBox(strMsg);
		}
		else
		{
			while (InternetReadFile(hResourceHandle, lpszBuffer, 255, &dwRead))
			{
				if (dwRead == 0)
					break;
				lpszBuffer[dwRead]=0;
				m_strResult += lpszBuffer;
			}
		}
	}
	//cleanup
	InternetCloseHandle(hResourceHandle);
	InternetCloseHandle(hConnectHandle);
	InternetCloseHandle(hOpenHandle);

	//update dialog
	UpdateData(FALSE);
}
