// Copyright (c) 1998, Microsoft Systems Journal
// Author: Aaron Skonnard
//
// HttpObjectServer.cpp : Implementation of DLL Exports.
//

// Note: Proxy/Stub Information
//		To build a separate proxy/stub DLL, 
//		run nmake -f HttpObjectServerps.mk in the project directory.

#include "stdafx.h"
#include "resource.h"
#include "initguid.h"
#include "HttpObjectServer.h"

#include "HttpObjectServer_i.c"
#include "HttpRequest.h"

CComModule _Module;

CRITICAL_SECTION g_CS;

BEGIN_OBJECT_MAP(ObjectMap)
	OBJECT_ENTRY(CLSID_HttpRequest, CHttpRequest)
END_OBJECT_MAP()

class CHttpObjectServerApp : public CWinApp
{
public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
};

CHttpObjectServerApp theApp;

BOOL CHttpObjectServerApp::InitInstance()
{
	_Module.Init(ObjectMap, m_hInstance);
	InitializeCriticalSection(&g_CS);
	return CWinApp::InitInstance();
}

int CHttpObjectServerApp::ExitInstance()
{
	_Module.Term();
	return CWinApp::ExitInstance();
}

/////////////////////////////////////////////////////////////////////////////
// Used to determine whether the DLL can be unloaded by OLE

STDAPI DllCanUnloadNow(void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());
	return (AfxDllCanUnloadNow()==S_OK && _Module.GetLockCount()==0) ? S_OK : S_FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Returns a class factory to create an object of the requested type

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
	return _Module.GetClassObject(rclsid, riid, ppv);
}

/////////////////////////////////////////////////////////////////////////////
// DllRegisterServer - Adds entries to the system registry

STDAPI DllRegisterServer(void)
{
	// registers object, typelib and all interfaces in typelib
	return _Module.RegisterServer(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - Removes entries from the system registry

STDAPI DllUnregisterServer(void)
{
	_Module.UnregisterServer();
	return S_OK;
}


