// MyFTPDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MyFTP.h"
#include "MyFTPDlg.h"
#include "ConnectDlg.h"
#include "RenameDlg.h"
#include "CreateDirectoryDlg.h"
#include <wininet.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// preprocessor
//////////////////////////////////////
#define BUFFLEN				255
#define WILDCARD			"*.*"
#define MODE_ASCII			0
#define MODE_BINARY			1
#define CONTEXT_CONNECT		1
#define CONTEXT_GET			2
#define CONTEXT_PUT			3

// globals
//////////////////////////////////////
HINTERNET g_hSession = NULL;
HINTERNET g_hConnection = NULL;

void ProcessInternetError()
{
	DWORD dwError = GetLastError();
	CString strMsg;
	strMsg.Format("GetLastError returned %d", dwError);
	AfxMessageBox(strMsg);
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyFTPDlg dialog

CMyFTPDlg::CMyFTPDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMyFTPDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMyFTPDlg)
	m_strStatus = _T("");
	m_strRemote = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CMyFTPDlg::~CMyFTPDlg()
{
	if (g_hConnection)
		InternetCloseHandle(g_hConnection);
	if (g_hSession)
		InternetCloseHandle(g_hSession);
}

void CMyFTPDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMyFTPDlg)
	DDX_Control(pDX, IDC_LIST_REMOTE, m_RemoteList);
	DDX_Control(pDX, IDC_LIST_LOCAL, m_LocalList);
	DDX_Text(pDX, IDC_STATIC_STATUS, m_strStatus);
	DDX_Text(pDX, IDC_STATIC_REMOTE, m_strRemote);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMyFTPDlg, CDialog)
	//{{AFX_MSG_MAP(CMyFTPDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDCONNECT, OnConnect)
	ON_BN_CLICKED(IDCREATE, OnCreate)
	ON_BN_CLICKED(IDGET, OnGet)
	ON_BN_CLICKED(IDPUT, OnPut)
	ON_BN_CLICKED(IDRENAME, OnRename)
	ON_BN_CLICKED(IDREMOVE, OnRemove)
	ON_LBN_DBLCLK(IDC_LIST_REMOTE, OnDblclkListRemote)
	ON_LBN_DBLCLK(IDC_LIST_LOCAL, OnDblclkListLocal)
	ON_BN_CLICKED(IDREMOVEDIR, OnRemovedir)
	ON_BN_CLICKED(IDC_RADIO_ASCII, OnRadioAscii)
	ON_BN_CLICKED(IDC_RADIO_BINARY, OnRadioBinary)
	ON_BN_CLICKED(IDDISCONNECT, OnDisconnect)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyFTPDlg message handlers

BOOL CMyFTPDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	//change list box fonts
	m_font.CreatePointFont(100, "Courier");
	m_RemoteList.SetFont(&m_font);
	m_LocalList.SetFont(&m_font);

	//fill local list with TEMP directory
	GetTempPath(BUFFLEN, m_strLocalDir.GetBuffer(BUFFLEN));
	m_strLocalDir.ReleaseBuffer();
	m_strLocalDir += WILDCARD;
	FillLocalList();

	CButton* pButton = (CButton*)GetDlgItem(IDC_RADIO_ASCII);
	if (pButton)
	{
		pButton->SetCheck(TRUE);
		m_lMode = MODE_ASCII;
	}

	//Create the Internet session
	/////////////////////////////////////////////

	g_hSession = InternetOpen("MyFTP", INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, INTERNET_FLAG_ASYNC);
	if (g_hSession)
	{
		INTERNET_STATUS_CALLBACK dwStatusCallback;
		dwStatusCallback = InternetSetStatusCallback(g_hSession, MyStatusCallback);
		if (INTERNET_INVALID_STATUS_CALLBACK == dwStatusCallback)   
		{   
			AfxMessageBox("Error setting status callback");
		}
	}

	//////////////////////////////////////////////

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMyFTPDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMyFTPDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMyFTPDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMyFTPDlg::FillLocalList()
{
	m_LocalList.ResetContent();
	DlgDirList( m_strLocalDir.GetBuffer(BUFFLEN), IDC_LIST_LOCAL, IDC_STATIC_LOCAL, DDL_READWRITE|DDL_DIRECTORY|DDL_DRIVES );
	m_strLocalDir.ReleaseBuffer();
}

void CMyFTPDlg::FillRemoteList()
{	
	CString strFileName;
	WIN32_FIND_DATA FindFileData;
	HINTERNET hFindFile=NULL;

	m_RemoteList.ResetContent();

	if (hFindFile)
		InternetCloseHandle(hFindFile);

	hFindFile = FtpFindFirstFile(g_hConnection, NULL, &FindFileData, INTERNET_FLAG_RELOAD, 0); 
	if (hFindFile)
	{
        if ( (FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == FILE_ATTRIBUTE_DIRECTORY )
			strFileName.Format("%s <DIR>", FindFileData.cFileName);
		else 
			strFileName = FindFileData.cFileName;
		m_RemoteList.AddString(strFileName);

		while(InternetFindNextFile(hFindFile, &FindFileData))
		{
			if ( (FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == FILE_ATTRIBUTE_DIRECTORY )
				strFileName.Format("%s <DIR>", FindFileData.cFileName);
			else 
				strFileName = FindFileData.cFileName;
			m_RemoteList.AddString(strFileName);
		}
		InternetCloseHandle(hFindFile);
	}
	else
	{
		DWORD dwError = GetLastError();
		if (ERROR_IO_PENDING != dwError)
		{
			ProcessInternetError();
		}
	}
}	

void CMyFTPDlg::OnConnect() 
{
	CConnectDlg dlg;
	if (IDOK == dlg.DoModal())
	{
		//if already connected, disconnect 
		if (g_hConnection)
			InternetCloseHandle(g_hConnection);

		//connect
		g_hConnection = InternetConnect(g_hSession, dlg.m_strServer, INTERNET_DEFAULT_FTP_PORT,
			dlg.m_strUser, dlg.m_strPassword, INTERNET_SERVICE_FTP, INTERNET_FLAG_PASSIVE , CONTEXT_CONNECT);
		if (g_hConnection)
		{
			FillRemoteList();
		}
		else
		{
			DWORD dwError = GetLastError();
			if (ERROR_IO_PENDING != dwError)
			{
				ProcessInternetError();
			}
		}
		m_strRemote = dlg.m_strServer;
		UpdateData(FALSE);
	}
}

void CMyFTPDlg::OnDisconnect() 
{
	if (g_hConnection)
	{
		InternetCloseHandle(g_hConnection);
		g_hConnection = NULL;
	}
	m_RemoteList.ResetContent();
}

void CMyFTPDlg::OnGet() 
{
	if (!g_hConnection)
	{
		AfxMessageBox("You must first connect to an FTP server");
		return;
	}
	CString strFile;
	int iIndex = m_RemoteList.GetCurSel();
	if (LB_ERR == iIndex)
	{
		AfxMessageBox("You must select a remote file first");
		return;
	}
	m_RemoteList.GetText(iIndex, strFile);
	DWORD dwFlags;
	if (m_lMode == MODE_ASCII)
		dwFlags = FTP_TRANSFER_TYPE_ASCII;
	else 
		dwFlags = FTP_TRANSFER_TYPE_BINARY;
	BOOL bRet = FtpGetFile(g_hConnection, strFile, strFile, FALSE, FILE_ATTRIBUTE_NORMAL, dwFlags, CONTEXT_GET);
	if (bRet)
	{
		FillLocalList();
	}
	else
	{
		DWORD dwError = GetLastError();
		if (ERROR_IO_PENDING != dwError)
		{
			ProcessInternetError();
		}
	}
}

void CMyFTPDlg::OnPut() 
{
	if (!g_hConnection)
	{
		AfxMessageBox("You must first connect to an FTP server");
		return;
	}
	CString strFile;
	int iIndex = m_LocalList.GetCurSel();
	if (LB_ERR == iIndex)
	{
		AfxMessageBox("You must select a local file first");
		return;
	}
	m_LocalList.GetText(iIndex, strFile);
	DWORD dwFlags;
	if (m_lMode == MODE_ASCII)
		dwFlags = FTP_TRANSFER_TYPE_ASCII;
	else 
		dwFlags = FTP_TRANSFER_TYPE_BINARY;
	BOOL bRet = FtpPutFile(g_hConnection, strFile, strFile, dwFlags, CONTEXT_PUT);
	if (bRet)
	{
		FillRemoteList();
	}
	else
	{
		DWORD dwError = GetLastError();
		if (ERROR_IO_PENDING != dwError)
		{
			ProcessInternetError();
		}
	}
}

void CMyFTPDlg::OnCreate() 
{
	if (!g_hConnection)
	{
		AfxMessageBox("You must first connect to an FTP server");
		return;
	}
	CCreateDirectoryDlg dlg;
	if (IDOK == dlg.DoModal())
	{
		if (!FtpCreateDirectory(g_hConnection, dlg.m_strNewDirName))
			ProcessInternetError();
	}
}

void CMyFTPDlg::OnRename() 
{
	if (!g_hConnection)
	{
		AfxMessageBox("You must first connect to an FTP server");
		return;
	}
	CString strFile;
	int iIndex = m_RemoteList.GetCurSel();
	if (LB_ERR == iIndex)
	{
		AfxMessageBox("You must select a remote file first");
		return;
	}
	m_RemoteList.GetText(iIndex, strFile);
	CRenameDlg dlg;
	if (IDOK == dlg.DoModal())
	{
		if (!FtpRenameFile(g_hConnection, strFile, dlg.m_strNewName))
			ProcessInternetError();
	}
}

void CMyFTPDlg::OnRemove() 
{
	if (!g_hConnection)
	{
		AfxMessageBox("You must first connect to an FTP server");
		return;
	}
	CString strFile;
	int iIndex = m_RemoteList.GetCurSel();
	if (LB_ERR == iIndex)
	{
		AfxMessageBox("You must select a remote file first");
		return;
	}
	m_RemoteList.GetText(iIndex, strFile);
	if (IDOK == AfxMessageBox("Delete selected file from ftp server", MB_YESNO|MB_ICONQUESTION))
	{
		if (!FtpDeleteFile(g_hConnection, strFile))
			ProcessInternetError();
	}
}

void CMyFTPDlg::OnDblclkListRemote() 
{
	if (!g_hConnection)
	{
		AfxMessageBox("You must first connect to an FTP server");
		return;
	}
	CString strFile;
	int iIndex = m_RemoteList.GetCurSel();
	if (LB_ERR == iIndex)
		return;
	m_RemoteList.GetText(iIndex, strFile);
	iIndex = strFile.Find(" <DIR>");
	if (-1 != iIndex)
		strFile = strFile.Left(iIndex);
	FtpSetCurrentDirectory(g_hConnection, strFile);
}

void CMyFTPDlg::OnDblclkListLocal() 
{
	CString strFile;
	int iIndex = m_LocalList.GetCurSel();
	if (LB_ERR == iIndex)
		return;
	m_LocalList.GetText(iIndex, strFile);
	if (!DlgDirSelectEx(GetSafeHwnd(), strFile.GetBuffer(BUFFLEN), BUFFLEN, IDC_LIST_LOCAL))
		return;
	strFile.ReleaseBuffer();
	m_strLocalDir = strFile;
	FillLocalList();
}

void CMyFTPDlg::OnRemovedir() 
{
	if (!g_hConnection)
	{
		AfxMessageBox("You must first connect to an FTP server");
		return;
	}
	CString strFile;
	int iIndex = m_RemoteList.GetCurSel();
	if (LB_ERR == iIndex)
	{
		AfxMessageBox("You must select a remote directory first");
		return;
	}
	m_RemoteList.GetText(iIndex, strFile);
	iIndex = strFile.Find(" <DIR>");
	if (-1 != iIndex)
		strFile = strFile.Left(iIndex);
	if (IDOK == AfxMessageBox("Delete selected directory from ftp server", MB_YESNO|MB_ICONQUESTION))
	{
		if (!FtpRemoveDirectory(g_hConnection, strFile))
			ProcessInternetError();
	}
}

void CMyFTPDlg::OnRadioAscii() 
{
	m_lMode = MODE_ASCII;
}

void CMyFTPDlg::OnRadioBinary() 
{
	m_lMode = MODE_BINARY;
}

void CMyFTPDlg::OnCancel() 
{
	PostMessage(WM_QUIT);	
	CDialog::OnCancel();
}

VOID CALLBACK MyStatusCallback(
    HINTERNET hInternet,
    DWORD dwContext,
    DWORD dwInternetStatus,
    LPVOID lpvStatusInformation,
    DWORD dwStatusInformationLength
)
{
	CString strStatus;
	CMyFTPDlg* pDlg = (CMyFTPDlg*)AfxGetMainWnd();
	if (!pDlg)
		return;

	switch(dwInternetStatus)
	{
	case INTERNET_STATUS_RESOLVING_NAME:
		strStatus="Resolving name...";
		break;
	case INTERNET_STATUS_NAME_RESOLVED:	
		strStatus="Resolved name!";
		break;
	case INTERNET_STATUS_CONNECTING_TO_SERVER:
		strStatus="Connecting to server...";
		break;
	case INTERNET_STATUS_CONNECTED_TO_SERVER:
		strStatus="Connected to server!";
		break;
	case INTERNET_STATUS_SENDING_REQUEST:	
		strStatus="Sending request...";
		break;
	case INTERNET_STATUS_REQUEST_SENT:	
		strStatus="Request sent!";
		break;
	case INTERNET_STATUS_RECEIVING_RESPONSE:
		strStatus="Receiving response...";
		break;
	case INTERNET_STATUS_RESPONSE_RECEIVED:	
		strStatus="Response received!";
		break;
	case INTERNET_STATUS_CLOSING_CONNECTION:
		strStatus="Closing connection...";
		break;
	case INTERNET_STATUS_CONNECTION_CLOSED:	
		strStatus="Connection close!";
		break;
	case INTERNET_STATUS_HANDLE_CREATED:
		strStatus="Handle created!";
		break;
	case INTERNET_STATUS_HANDLE_CLOSING:
		strStatus="Closing handle...";
		break;
	case INTERNET_STATUS_REQUEST_COMPLETE:
		{
			strStatus="Request complete!";
			switch(dwContext)
			{
			case CONTEXT_GET:
				pDlg->FillLocalList();
				break;
			case CONTEXT_PUT:
				pDlg->FillRemoteList();
				break;
			case CONTEXT_CONNECT:
				{
					if (!g_hConnection)
					{
						LPINTERNET_ASYNC_RESULT pResult = (LPINTERNET_ASYNC_RESULT)(lpvStatusInformation);
						g_hConnection = (HINTERNET)pResult->dwResult;
					}
					pDlg->FillRemoteList();
				}
				break;
			default:
				AfxMessageBox("Invalid dwContext value");
				break;
			}
		}
		break;
	default:
		strStatus="";
		break;
	}
	CWnd* pText = NULL;
	if (pDlg)
		pText = pDlg->GetDlgItem(IDC_STATIC_STATUS);
	if (pText)
		pText->SetWindowText(strStatus);
}

