// MyGopherDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MyGopher.h"
#include "MyGopherDlg.h"
#include "FileDownloadDlg.h"
#include "SearchDlg.h"
#include "CreateLocatorDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyGopherDlg dialog

CMyGopherDlg::CMyGopherDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMyGopherDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMyGopherDlg)
	m_strServer = _T("");
	m_strLocator = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	//initialize HINTERNET handles
	m_hSession = NULL;
	m_hConnection = NULL;
}

void CMyGopherDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMyGopherDlg)
	DDX_Control(pDX, IDC_LIST_RESULT, m_List);
	DDX_Text(pDX, IDC_EDIT_SERVER, m_strServer);
	DDX_Text(pDX, IDC_EDIT_LOCATOR, m_strLocator);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMyGopherDlg, CDialog)
	//{{AFX_MSG_MAP(CMyGopherDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_NOTIFY(NM_DBLCLK, IDC_LIST_RESULT, OnDblclkListResult)
	ON_NOTIFY(NM_CLICK, IDC_LIST_RESULT, OnClickListResult)
	ON_BN_CLICKED(IDGET, OnGet)
	ON_BN_CLICKED(IDTYPE, OnType)
	ON_BN_CLICKED(IDCREATELOC, OnCreateLocator)
	ON_BN_CLICKED(IDCONNECT, OnConnect)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyGopherDlg message handlers

BOOL CMyGopherDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Initialize the list view control
	m_List.InsertColumn(0, "Display String", LVCFMT_LEFT, 250);
	m_List.InsertColumn(1, "Type", LVCFMT_LEFT, 75);
	m_List.InsertColumn(2, "Size High", LVCFMT_LEFT, 75);
	m_List.InsertColumn(3, "Size Low", LVCFMT_LEFT, 75);
	m_List.InsertColumn(4, "Locator", LVCFMT_LEFT, 75);
	ListView_SetExtendedListViewStyle(m_List.GetSafeHwnd(), LVS_EX_FULLROWSELECT);

	// Initialize the Internet session for application
	m_hSession = InternetOpen("MyGopher/1.0", INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, 0);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMyGopherDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMyGopherDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMyGopherDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

CString GetGopherTypeString(DWORD type)
{
	CString strType;

	// Get the gopher type string
	// using utility macros
	if (IS_GOPHER_FILE(type))
		strType = "File";
	else if (IS_GOPHER_DIRECTORY(type))
		strType = "<DIR>";
	else if (IS_GOPHER_PHONE_SERVER(type))
		strType = "Phone";
	else if (IS_GOPHER_ERROR(type))
		strType = "Error";
	else if (IS_GOPHER_INDEX_SERVER(type))
		strType = "Index";
	else if (IS_GOPHER_TELNET_SESSION(type))
		strType = "Telnet";
	else if (IS_GOPHER_BACKUP_SERVER(type))
		strType = "Backup";
	else if (IS_GOPHER_TN3270_SESSION(type))
		strType = "TN3270";
	else if (IS_GOPHER_ASK(type))
		strType = "Ask";
	else if (IS_GOPHER_PLUS(type))
		strType = "Gopher+";
	return strType;
}

void CMyGopherDlg::FindGopherFiles(LPCTSTR lpszLocator, LPCTSTR lpszSearch/*=NULL*/)
{
	// make sure there is a connection
	if (!m_hConnection)
		return;

	m_List.DeleteAllItems();

	HINTERNET hFind;
	GOPHER_FIND_DATA file;

	// begin gopher enumeration, using search string if available
	if (strlen(lpszLocator))
		hFind = GopherFindFirstFile(m_hConnection, lpszLocator, lpszSearch, &file, 0, 0);
	else
		hFind = GopherFindFirstFile(m_hConnection, NULL, lpszSearch, &file, 0, 0);

	if (hFind)
	{
		CString strText;
		UINT index = 0;

		//insert main item
		LV_ITEM item;
		item.mask = LVIF_TEXT;
		item.iItem = index++;
		item.iSubItem = 0;
		item.pszText = file.DisplayString;
		m_List.InsertItem(&item);
		//insert subitems
		strText = GetGopherTypeString(file.GopherType);
		m_List.SetItemText(item.iItem, 1, strText);
		strText.Format("%d", file.SizeLow);
		m_List.SetItemText(item.iItem, 2, strText);
		strText.Format("%d", file.SizeHigh);
		m_List.SetItemText(item.iItem, 3, strText);
		strText = file.Locator;
		m_List.SetItemText(item.iItem, 4, strText);

		// continue enumeration using InternetFindNextFile
		while (InternetFindNextFile(hFind, &file))
		{
			item.mask = LVIF_TEXT;
			item.iItem = index++;
			item.iSubItem = 0;
			item.pszText = file.DisplayString;
			m_List.InsertItem(&item);
		
			strText = GetGopherTypeString(file.GopherType);
			m_List.SetItemText(item.iItem, 1, strText);
			strText.Format("%d", file.SizeLow);
			m_List.SetItemText(item.iItem, 2, strText);
			strText.Format("%d", file.SizeHigh);
			m_List.SetItemText(item.iItem, 3, strText);
			strText = file.Locator;
			m_List.SetItemText(item.iItem, 4, strText);
		}
		// close enumeration handle
		InternetCloseHandle(hFind);
	}
}


void CMyGopherDlg::OnConnect() 
{
	UpdateData(TRUE);

	// if already connected, disconnect
	if (!m_hConnection)
		InternetCloseHandle(m_hConnection);

	// connect to gopher server using default gopher port
	m_hConnection = InternetConnect(m_hSession, m_strServer, INTERNET_DEFAULT_GOPHER_PORT,
							NULL, NULL, INTERNET_SERVICE_GOPHER, 0, 0);

	// enumerate gopher items using empty locator
	FindGopherFiles("");

	UpdateData(FALSE);
}

void CMyGopherDlg::OnClose() 
{
	// close the Internet session handle
	InternetCloseHandle(m_hSession);
	CDialog::OnClose();
}

void CMyGopherDlg::Search(CString& strLocator)
{
	// query user for search string
	CSearchDlg dlg;
	if (IDOK==dlg.DoModal())
	{
		// enumerate gopher items returned by search index
		FindGopherFiles(strLocator, dlg.m_strSearch);
	}
}

void CMyGopherDlg::OnDblclkListResult(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// make sure there is a connection
	if (!m_hConnection)
		return;

	// get selected item
	UINT index = m_List.GetNextItem(-1 , LVNI_SELECTED);
	if (index == -1)
		return;

	// get locator type string for selected item
	CString strType = m_List.GetItemText(index, 1);
	// get locator string for selected item
	CString strLocator = m_List.GetItemText(index, 4);

	// enumerate, search, or download depending on type
	if (strType.Compare("<DIR>") == 0)
		FindGopherFiles(strLocator);
	else if (strType.Compare("Index") == 0)
		Search(strLocator);
	else if (strType.Compare("File") == 0)
		GetFile(strLocator);
	
	//update dialog
	m_strLocator.Empty();		
	UpdateData(FALSE);
	*pResult = 0;
}

void CMyGopherDlg::OnClickListResult(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// simply show locator in edit box
	UINT index = m_List.GetNextItem(-1, LVNI_SELECTED);
	if (index == -1)
		return;
	CString strLocator = m_List.GetItemText(index, 4);
	m_strLocator = strLocator;
	UpdateData(FALSE);
	*pResult = 0;
}

void CMyGopherDlg::GetFile(CString& strLocator)
{
	DWORD dwToRead=4095, dwRead;
	char szBuffer[4096];
	CString strFile;

	// open the remote gopher file
	HINTERNET hFile = GopherOpenFile(m_hConnection, strLocator, NULL, 0, 0);

	// read the file until finished
	while (InternetReadFile(hFile, szBuffer, dwToRead, &dwRead))
	{
		if (dwRead == 0)
			break;
		szBuffer[dwRead]=0;
		strFile += szBuffer;
	}

	// show downloaed test in dialog
	CFileDownloadDlg dlg;
	dlg.m_strFileText = strFile;
	dlg.DoModal();	
}

void CMyGopherDlg::OnGet() 
{
	// get selected item information
	UINT index = m_List.GetNextItem(-1, LVNI_SELECTED);
	if (index == -1)
		return;
	CString strType = m_List.GetItemText(index, 1);
	if (strType.Compare("File") != 0)
		return;
	CString strLocator = m_List.GetItemText(index, 4);

	// download file
	GetFile(strLocator);
}

void CMyGopherDlg::OnType() 
{
	DWORD dwType;
	CString strType;

	// get selected item information
	UINT index = m_List.GetNextItem(-1, LVNI_SELECTED);
	if (index == -1)
		return;
	CString strLocator = m_List.GetItemText(index, 4);

	// display locator type number
	if (!GopherGetLocatorType(strLocator, &dwType))
		return;
	strType.Format("Locator type = %lu", dwType);
	AfxMessageBox(strType);
}

void CMyGopherDlg::OnCreateLocator() 
{
	// query user for locator parameters
	CCreateLocatorDlg dlg;
	if (IDCANCEL == dlg.DoModal())
		return;

	DWORD dwType, dwLen=4096;
	char szBuffer[4096];

	// figure out the WinInet gopher type value
	switch (dlg.m_nType)
	{
	case 0:
		dwType = GOPHER_TYPE_ASK;
		break;
	case 1:
		dwType = GOPHER_TYPE_BINARY;
		break;
	case 2:
		dwType = GOPHER_TYPE_BITMAP;
		break;
	case 3:
		dwType = GOPHER_TYPE_CALENDAR;
		break;
	case 4:
		dwType = GOPHER_TYPE_CSO;
		break;
	case 5:
		dwType = GOPHER_TYPE_DIRECTORY;
		break;
	case 6:
		dwType = GOPHER_TYPE_DOS_ARCHIVE;
		break;
	case 7:
		dwType = GOPHER_TYPE_ERROR;
		break;
	case 8:
		dwType = GOPHER_TYPE_GIF;
		break;
	case 9:
		dwType = GOPHER_TYPE_GOPHER_PLUS;
		break;
	case 10:
		dwType = GOPHER_TYPE_HTML;
		break;
	case 11:
		dwType = GOPHER_TYPE_IMAGE;
		break;
	case 12:
		dwType = GOPHER_TYPE_INDEX_SERVER;
		break;
	case 13:
		dwType = GOPHER_TYPE_INLINE;
		break;
	case 14:
		dwType = GOPHER_TYPE_MAC_BINHEX;
		break;
	case 15:
		dwType = GOPHER_TYPE_MOVIE;
		break;
	case 16:
		dwType = GOPHER_TYPE_PDF;
		break;
	case 17:
		dwType = GOPHER_TYPE_REDUNDANT;
		break;
	case 18:
		dwType = GOPHER_TYPE_SOUND;
		break;
	case 19:
		dwType = GOPHER_TYPE_TELNET;
		break;
	case 20:
		dwType = GOPHER_TYPE_TEXT_FILE;
		break;
	case 21:
		dwType = GOPHER_TYPE_TN3270;
		break;
	case 22:
		dwType = GOPHER_TYPE_UNIX_UUENCODED;
		break;
	default:
		dwType = GOPHER_TYPE_UNKNOWN;
		break;
	}

	// create the locator string
	if (GopherCreateLocator(dlg.m_strHost, dlg.m_nPort, dlg.m_strDisplay,
			dlg.m_strSelector, dwType, szBuffer, &dwLen))
	{
		// enumerate, search, or download depending on type
		m_strLocator = szBuffer;
		switch(dwType)
		{
		case GOPHER_TYPE_DIRECTORY:
			FindGopherFiles(m_strLocator);
			break;
		case GOPHER_TYPE_HTML:
		case GOPHER_TYPE_TEXT_FILE:
			GetFile(m_strLocator);
			break;
		case GOPHER_TYPE_INDEX_SERVER:
			Search(m_strLocator);
			break;
		default:
			break;
		}
		UpdateData(FALSE);
	}
}

