// ProviderDatek.h : Declaration of the CProviderDatek

#ifndef __PROVIDERDATEK_H_
#define __PROVIDERDATEK_H_

#include "resource.h"       // main symbols
#include "CPQuoteProviders.h"

/////////////////////////////////////////////////////////////////////////////
// CProviderDatek
class ATL_NO_VTABLE CProviderDatek : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CProviderDatek, &CLSID_ProviderDatek>,
	public IConnectionPointContainerImpl<CProviderDatek>,
	public CProxyIQuoteProviderEvent<CProviderDatek>,
	public IQuoteProvider
{
public:
	CProviderDatek()
	{
	}
	CStringArray m_arrSymbols;
	CStringArray m_arrSearchKeys;
	CString m_strDataLine;
	CString m_strURL;

DECLARE_REGISTRY_RESOURCEID(IDR_PROVIDERDATEK)

BEGIN_COM_MAP(CProviderDatek)
	COM_INTERFACE_ENTRY(IQuoteProvider)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(CProviderDatek)
    CONNECTION_POINT_ENTRY(IID_IQuoteProviderEvent)
END_CONNECTION_POINT_MAP()


// IProviderDatek
public:
	STDMETHOD(InitializeData)(LPSTR lpszData);
	STDMETHOD(ParseResult)(LPSTR lpszResult);
	STDMETHOD(GetData)(LPSTR lpszData, DWORD dwLen);
	STDMETHOD(GetHeaders)(LPSTR lpszHeaders, DWORD dwLen);
	STDMETHOD(GetFlags)(DWORD* pdwFlags);
	STDMETHOD(GetHttpVersion)(LPSTR lpszHttpVersion, DWORD dwLen);
	STDMETHOD(GetAcceptTypes)(LPSTR lpszAcceptTypes, DWORD dwLen);
	STDMETHOD(GetURL)(LPSTR lpszURL, DWORD dwLen);
	STDMETHOD(GetMethod)(LPSTR lpszMethod, DWORD dwLen);
	STDMETHOD(LoginIsRequired)(BOOL* pbResult);
	STDMETHOD(GetPort)(USHORT* pnPort);
	STDMETHOD(GetHost)(LPSTR lpszHost, DWORD dwLen);
protected:
	HRESULT ParseFraction(CString& strPrice, LPSTR lpszPriceBegin, LPSTR lpszPriceEnd);
	HRESULT ParseSymbol(long lIndex, LPSTR lpszResult);
};

#endif //__PROVIDERDATEK_H_
