// Copyright (c) 1998, Microsoft Interactive Developer
// Author: Aaron Skonnard
//
// RasJazzDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RasJazz.h"
#include "RasJazzDlg.h"
#include "AutoDialAddressesDlg.h"
#include "AutoDialSettingsDlg.h"
#include "EntrySettingsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

UINT WaitForRasNotificationsThread(LPVOID lpvoid);

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRasJazzDlg dialog

CRasJazzDlg::CRasJazzDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRasJazzDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRasJazzDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRasJazzDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRasJazzDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRasJazzDlg, CDialog)
	//{{AFX_MSG_MAP(CRasJazzDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_AUTO_DIAL_ADDRESSES, OnAutoDialAddresses)
	ON_BN_CLICKED(IDC_AUTO_DIAL_SETTINGS, OnAutoDialSettings)
	ON_BN_CLICKED(IDC_RAS_ENTRY_SETTINGS, OnRasEntrySettings)
	ON_BN_CLICKED(IDC_PHONEBOOK_DLG, OnPhonebookDlg)
	ON_BN_CLICKED(IDC_MONITOR_DLG, OnMonitorDlg)
	ON_BN_CLICKED(IDC_ENTRY_DLG, OnEntryDlg)
	ON_BN_CLICKED(IDC_DIAL_DLG, OnDialDlg)
	ON_BN_CLICKED(IDC_NOTIFY_WAIT, OnNotifyWait)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRasJazzDlg message handlers

BOOL CRasJazzDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRasJazzDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRasJazzDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRasJazzDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRasJazzDlg::OnAutoDialAddresses() 
{
	CAutoDialAddressesDlg dlg;
	dlg.DoModal();
}

void CRasJazzDlg::OnAutoDialSettings() 
{
	CAutoDialSettingsDlg dlg;
	dlg.DoModal();
}

void CRasJazzDlg::OnRasEntrySettings() 
{
	CEntrySettingsDlg dlg;
	dlg.DoModal();
}

void CRasJazzDlg::OnPhonebookDlg() 
{
	RASPBDLG raspbdlg;
	raspbdlg.dwSize = sizeof(RASPBDLG);
	raspbdlg.hwndOwner = GetSafeHwnd();
    raspbdlg.dwFlags = 0;
	raspbdlg.xDlg = 0;
    raspbdlg.yDlg = 0;
	raspbdlg.dwCallbackId = 0;
    raspbdlg.pCallback = 0;
	raspbdlg.dwError = 0;
    raspbdlg.reserved = 0; 
	raspbdlg.reserved2 = 0;
	RasPhonebookDlg(NULL, NULL, &raspbdlg);
}

void CRasJazzDlg::OnMonitorDlg() 
{
	RASMONITORDLG rasmonitordlg;
    rasmonitordlg.dwSize = sizeof(RASMONITORDLG);   
	rasmonitordlg.hwndOwner = GetSafeHwnd();
	rasmonitordlg.dwFlags = 0;
    rasmonitordlg.dwStartPage = 0;    
	rasmonitordlg.xDlg = 0;
	rasmonitordlg.yDlg = 0;
    rasmonitordlg.dwError = 0;   
	rasmonitordlg.reserved = 0; 
	rasmonitordlg.reserved2 = 0;
	RasMonitorDlg(NULL, &rasmonitordlg);
}

void CRasJazzDlg::OnEntryDlg() 
{
	RASENTRYDLG rasentrydlg;
    rasentrydlg.dwSize = sizeof(RASENTRYDLG);
	rasentrydlg.hwndOwner = GetSafeHwnd();
	rasentrydlg.dwFlags = 0;
    rasentrydlg.xDlg = 0;
	rasentrydlg.yDlg = 0;
	rasentrydlg.dwError = 0;
    rasentrydlg.reserved = 0; 
	rasentrydlg.reserved2 = 0;
	RasEntryDlg(NULL, "ReliaNet", &rasentrydlg); 
}

void CRasJazzDlg::OnDialDlg() 
{
	RASDIALDLG rasdialdlg;
	rasdialdlg.dwSize = sizeof(RASDIALDLG);
	rasdialdlg.hwndOwner = GetSafeHwnd();
	rasdialdlg.dwFlags = 0;
	rasdialdlg.xDlg = 0;
	rasdialdlg.yDlg = 0;
	rasdialdlg.dwSubEntry = 0;
	rasdialdlg.dwError = 0;
	rasdialdlg.reserved = 0;
	rasdialdlg.reserved2 = 0;
	RasDialDlg(NULL, "ReliaNet", "", &rasdialdlg);
}


UINT WaitForRasNotificationsThread(LPVOID lpvoid)
{
	HANDLE hEvent = CreateEvent(NULL, FALSE, FALSE, "RasNotification");
	if (hEvent)
		RasConnectionNotification((HRASCONN)INVALID_HANDLE_VALUE, hEvent, 
			RASCN_Connection | RASCN_Disconnection | RASCN_BandwidthAdded | RASCN_BandwidthRemoved);

	if (WAIT_OBJECT_0 == WaitForSingleObject(hEvent, INFINITE))
	{
		::MessageBox(NULL, "Ras notification recieved", "Aaron's RAS Notification", MB_OK | MB_SETFOREGROUND );
		CloseHandle(hEvent);
	}
	return 0;
}

void CRasJazzDlg::OnNotifyWait() 
{
	AfxBeginThread(WaitForRasNotificationsThread, NULL);
}

